diff -Naur crosstool-0.28-rc5-orig/getandpatch.sh crosstool-0.28-rc5/getandpatch.sh
--- crosstool-0.28-rc5-orig/getandpatch.sh	2004-04-16 22:22:23.000000000 -0700
+++ crosstool-0.28-rc5/getandpatch.sh	2004-06-19 12:17:30.000000000 -0700
@@ -15,7 +15,13 @@
 test -z "${BINUTILS_DIR}"     && abort "Please set BINUTILS_DIR to the bare filename of the binutils tarball or directory"
 test -z "${SRC_DIR}"          && abort "Please set SRC_DIR to the directory where the source tarballs are to be unpacked"
 test -z "${GCC_DIR}"          && abort "Please set GCC_DIR to the bare filename of the gcc tarball or directory"
-test -z "${GLIBC_DIR}"        && abort "Please set GLIBC_DIR to the bare filename of the glibc tarball or directory"
+test -z "${LIBC_DIR}"         && abort "Please set LIBC_DIR to the bare filename of the C library tarball or directory"
+test -z "${C_LIBRARY}"        && abort "Please set C_LIBRARY to 'glibc' or 'uclibc'"
+case ${C_LIBRARY} in
+    glibc)  ;;
+    uclibc) ;;
+    *)      abort "Unsupported C library ${C_LIBRARY}; please set C_LIBRARY to 'glibc' or 'uclibc'"
+esac
 test -z "${LINUX_DIR}"        && abort "Please set LINUX_DIR to the bare filename of the kernel tarball or directory"
 test -z "${TARBALLS_DIR}"     && abort "Please set TARBALLS_DIR to the directory to download tarballs to."
 test -z "${PTXDIST_DIR}"      && abort "Please set PTXDIST_DIR to the bare filename of the ptxdist tarball or directory."
@@ -28,7 +34,9 @@
 if test -z "$QUIET_EXTRACTIONS"; then VERBOSE=-v;else VERBOSE=; fi
 
 # And one is derived.
-GLIBCTHREADS_FILENAME=`echo $GLIBC_DIR | sed 's/glibc-/glibc-linuxthreads-/'`
+if test "${C_LIBRARY}" = glibc ; then
+    GLIBCTHREADS_FILENAME=`echo $LIBC_DIR | sed 's/glibc-/glibc-linuxthreads-/'`
+fi
 
 # Pattern in a patch log to indicate failure
 PATCHFAILMSGS="^No file to patch.  Skipping patch.|^Hunk .* FAILED at"
@@ -86,7 +94,7 @@
     cd $SRC_DIR
 
     case $ARCHIVE_NAME in
-    glibc-*-2.*) echo "It's a glibc addon, so cd into glibc"; cd $GLIBC_DIR ;;
+    glibc-*-2.*) echo "It's a glibc addon, so cd into glibc"; cd $LIBC_DIR ;;
     *) ;;
     esac
 
@@ -133,6 +141,14 @@
     fi
 }
 
+# Special version for uClibc pregenerated locale data
+getuClibcLocale() {
+    ARCHIVE_NAME=`echo $1 | sed 's,.*/,,;'`
+    cd ${SRC_DIR}/${LIBC_DIR}/extra/locale
+    test -f ${ARCHIVE_NAME} || wget $1
+    cd ${TOP_DIR}
+}
+
 # Remember where source is.
 TOP_DIR=${TOP_DIR-`pwd`}
 
@@ -158,15 +174,26 @@
    *)
       getUnpackAndPatch ftp://ftp.gnu.org/pub/gnu/gcc/$GCC_DIR.tar.gz ;;
 esac
-getUnpackAndPatch ftp://ftp.gnu.org/pub/gnu/glibc/$GLIBC_DIR.tar.bz2 ftp://ftp.gnu.org/pub/gnu/glibc/$GLIBC_DIR.tar.gz
+case $C_LIBRARY in
+   glibc)
+      getUnpackAndPatch ftp://ftp.gnu.org/pub/gnu/glibc/$LIBC_DIR.tar.bz2 ftp://ftp.gnu.org/pub/gnu/glibc/$LIBC_DIR.tar.gz
+      # Glibc addons must come after glibc
+      test x$GLIBCTREADS_FILENAME = x || getUnpackAndPatch     ftp://ftp.gnu.org/pub/gnu/glibc/$GLIBCTHREADS_FILENAME.tar.bz2 ftp://ftp.gnu.org/pub/gnu/glibc/$GLIBCTHREADS_FILENAME.tar.gz
+      test x$GLIBCCRYPT_FILENAME = x || getUnpackAndPatch     ftp://ftp.gnu.org/pub/gnu/glibc/$GLIBCCRYPT_FILENAME.tar.gz ftp://ftp.gnu.org/pub/gnu/glibc/$GLIBCCRYPT_FILENAME.tar.bz2
+      ;;
+   uclibc)
+      getUnpackAndPatch http://www.uclibc.org/downloads/old-releases/$LIBC_DIR.tar.bz2 || \
+          getUnpackAndPatch http://www.uclibc.org/downloads/old-releases/$LIBC_DIR.tar.gz || \
+          getUnpackAndPatch http://www.uclibc.org/downloads/$LIBC_DIR.tar.bz2 || \
+          getUnpackAndPatch http://www.uclibc.org/downloads/$LIBC_DIR.tar.gz
+      getuClibcLocale http://www.uclibc.org/downloads/uClibc-locale-030818.tgz
+      ;;
+esac
 case $LINUX_DIR in
   *2.4*) getUnpackAndPatch http://www.kernel.org/pub/linux/kernel/v2.4/$LINUX_DIR.tar.bz2 http://www.kernel.org/pub/linux/kernel/v2.4/$LINUX_DIR.tar.gz ;;
   *2.6*) getUnpackAndPatch http://www.kernel.org/pub/linux/kernel/v2.6/$LINUX_DIR.tar.bz2 http://www.kernel.org/pub/linux/kernel/v2.6/$LINUX_DIR.tar.gz ;;
   *) abort "unknown version $LINUX_DIR of linux, expected 2.4 or 2.6 in name?" ;;
 esac
-# Glibc addons must come after glibc
-getUnpackAndPatch     ftp://ftp.gnu.org/pub/gnu/glibc/$GLIBCTHREADS_FILENAME.tar.bz2 ftp://ftp.gnu.org/pub/gnu/glibc/$GLIBCTHREADS_FILENAME.tar.gz
-test x$GLIBCCRYPT_FILENAME = x || getUnpackAndPatch     ftp://ftp.gnu.org/pub/gnu/glibc/$GLIBCCRYPT_FILENAME.tar.gz ftp://ftp.gnu.org/pub/gnu/glibc/$GLIBCCRYPT_FILENAME.tar.bz2
 
 # gcc's contrib/test_summary expects version stamp, normally created by contrib/update_gcc
 test -f $SRC_DIR/$GCC_DIR/LAST_UPDATED || echo $GCC_DIR > $SRC_DIR/$GCC_DIR/LAST_UPDATED
diff -Naur crosstool-0.28-rc5-orig/ptx.sh crosstool-0.28-rc5/ptx.sh
--- crosstool-0.28-rc5-orig/ptx.sh	2004-03-18 10:23:02.000000000 -0800
+++ crosstool-0.28-rc5/ptx.sh	2004-06-19 12:17:30.000000000 -0700
@@ -6,10 +6,16 @@
 
 test -z "${TARGET}"           && abort "Please set TARGET to the Gnu target identifier (e.g. pentium-linux)"
 test -z "${GCC_DIR}"          && abort "Please set GCC_DIR to the bare filename of the gcc tarball or directory"
-test -z "${GLIBC_DIR}"        && abort "Please set GLIBC_DIR to the bare filename of the glibc tarball or directory"
+test -z "${LIBC_DIR}"         && abort "Please set LIBC_DIR to the bare filename of the C library tarball or directory"
+test -z "${C_LIBRARY}"        && abort "Please set C_LIBRARY to 'glibc' or 'uclibc'"
+case ${C_LIBRARY} in
+    glibc)  ;;
+    uclibc) ;;
+    *)      abort "Unsupported C library ${C_LIBRARY}; please set C_LIBRARY to 'glibc' or 'uclibc'"
+esac
 test -z "${PTXDIST_DIR}"      && abort "Please set PTXDIST_DIR to the bare filename of the ptxdist tarball or directory"
 
-TOOLCOMBO=$GCC_DIR-$GLIBC_DIR
+TOOLCOMBO=$GCC_DIR-$LIBC_DIR
 TOP_DIR=${TOP_DIR-`pwd`}
 BUILD_DIR=$TOP_DIR/build/$TARGET/$TOOLCOMBO
 
diff -Naur crosstool-0.28-rc5-orig/testhello.sh crosstool-0.28-rc5/testhello.sh
--- crosstool-0.28-rc5-orig/testhello.sh	2004-01-16 10:54:39.000000000 -0800
+++ crosstool-0.28-rc5/testhello.sh	2004-06-19 12:17:30.000000000 -0700
@@ -1,8 +1,14 @@
 #!/bin/sh
 set -ex
 
+if test x"$1" = x ; then
+    TESTLANG=c,c++
+else
+    TESTLANG="$1"
+fi
+
 cd $PREFIX
-mkdir tmp
+test -d tmp || mkdir tmp
 cd tmp
 
 # Test the C compiler
@@ -15,14 +21,17 @@
 $PREFIX/bin/$TARGET-gcc -static hello.c -o $TARGET-hello-static
 $PREFIX/bin/$TARGET-gcc hello.c -o $TARGET-hello
 
-# Test the C++ compiler.
-# Link statically, to maximize chances the program will run on any random target.
+if echo "$TESTLANG" | egrep "(^|,)c++(,|\$)"; then
+    # Test the C++ compiler.
+    # Link statically, to maximize chances the program will run on any
+    # random target.
 
-cat > hello2.cc <<_eof_
+    cat > hello2.cc <<_eof_
 #include <iostream>
 int main() { std::cout << "Hello, c++!\n"; return 0; }
 _eof_
 
-$PREFIX/bin/$TARGET-g++ -static hello2.cc -o $TARGET-hello2-static
-$PREFIX/bin/$TARGET-g++ hello2.cc -o $TARGET-hello2
+    $PREFIX/bin/$TARGET-g++ -static hello2.cc -o $TARGET-hello2-static
+    $PREFIX/bin/$TARGET-g++ hello2.cc -o $TARGET-hello2
+fi
 
